/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
  "use strict";
  rJS(window)
  
  .declareAcquiredMethod("add_to_index", "add_to_index")
  .declareAcquiredMethod("is_db_empty", "is_db_empty")
  
  .allowPublicAcquisition("add", function (page) {
    return this.add_to_index(page[0]);
  })
  
  .setState({
    to_load: [
      // "44_svt.xml", //136 urls
      // "allemandfacile.xml", //650 urls
      // "anglaisfacile.xml", //567 urls
      // "bescherelle.xml", //65 urls
      // "codeacademy.xml", //27 urls
      // "francaisfacile.xml", //1119 urls
      // "hgeo_college.xml", //226 urls
      // "histoirencours.xml", //1415 urls
      // "italienfacile.xml", //1477 urls
      // "jerevise.xml", //918 urls
      // "junior_science_et_vie.xml", //532 urls
      // "kmusic.xml", //106 urls ---
      "larousse.xml", //4563 urls
      // //"letudiant.xml", //41649 urls
      // "lewebpedagogique.xml", //298 urls
      // //"livrespourtous.xml", //12061 urls
      //  "mathovore.xml", //2221 urls
      // "monanneeaucollege.xml", //120 urls
      // "nosdevoirs.xml", //462 urls
      // "physagreg.xml", //150 urls
      // "physique_chimie_college.xml", //282 urls
      // "reviser_brevet.xml", //229 urls
      // "soutien67.xml", //1604 urls
      // //"superprof.xml", //12296 urls
      // "technologieaucollege27.xml", //128 urls
      //  "espagnolfacile.xml", //3352 urls
      // "vivelessvt.xml" //1257 urls
     ]
  })
  
  .ready(function(){
    var gadget = this;
    return gadget.getDeclaredGadget("parser")
      .push(function(parser_gadget){
        return gadget.changeState({
          parser_gadget : parser_gadget
        });
      });
  })
  
  .declareMethod("init", function(){
    var gadget = this,
        promise_list = [];

    return gadget.is_db_empty()
      .push(function(empty){
        if (empty) {
          for (var i=0; i<gadget.state.to_load.length; i+=1){
            promise_list.push(gadget.load_file("../../../crawler_test/" + gadget.state.to_load[i]));
          }
          return RSVP.all(promise_list);
        }
      });
  })
  
  .declareMethod("load_file", function(file_link){ //OK
    var gadget = this;
    console.log("loading " + file_link);
    return new RSVP.Queue()
      .push(function(){
        return jIO.util.ajax({url : file_link});
      })
      .push(function(file){
        return gadget.state.parser_gadget.concurrent_parse(file.currentTarget.responseText);
      })
      .push(undefined, function (my_error) {console.log(my_error)});
  });

}(window, RSVP, rJS, jIO));