/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function (window, document, RSVP, rJS, jIO) {
 "use strict";
 rJS(window)
 
 .ready(function(){
    var index, db;
    
    var index = FlexSearch.create("memory");
    
    db = jIO.createJIO(
      {
          type : "query",
          sub_storage : {
            type : "uuid",
            sub_storage : {
              type : "indexeddb",
              database : "mynij"
            }
          }
      }
    );
    
    /*db = jIO.createJIO(
      {
        type : "zip",
        sub_storage : {
          type : "query",
          sub_storage : {
            type : "uuid",
            sub_storage : {
              type : "indexeddb",
              database : "mynij"
            }
          }
        }
      }
    );*/
    
    this.changeState({
      index : index,
      db : db,
      msgpack : msgpack
    });
    
    return this._load_index();
 })
 
 .declareMethod("add_page", function(page_info){ //page_info = {link, title, description, item}
    var gadget = this,
        tmp;
    tmp = page_info;
    tmp.portal_type = "page";
    return gadget.state.db.post(tmp)
      .push(function(){
        return gadget.state.db.post(tmp);
      })
      .push(function(){
        for (var i = 0; i < 5; i += 1){
          gadget.state.index.add("title_"+page_info.link+"_"+i, page_info.title);
          gadget.state.index.add("body_"+page_info.link+"_"+i, page_info.item); 
        }
      })
/*      .push(function(){
        return gadget._save_index();
      })*/;
 })
 
 .declareMethod("_save_index", function(){ //OK
    //console.log("saving index");
    var gadget = this;
    var stringified = this.state.index.export(this.state.msgpack);
    if (this.state.index_id){
      return gadget.state.db.put(gadget.state.db.index_id, {"portal_type" : "index", "index" : stringified});
    } else {
      return gadget.state.db.post({"portal_type" : "index", "index" : stringified})
        .push(function(created_id){
          return gadget.changeState({
            index_id : created_id
          });
        });
    }
 })
 
 .declareMethod("search", function(query){
   return this.state.index.search(query);
 })
 
 .declareMethod("_load_index", function(msgpack){ //OK
   var gadget = this,
       query = 'portal_type:"index"',
       id;
   return this.state.db.allDocs({"query" : query})
    .push(function(result){
      if (result.data.total_rows !== 0){
        console.log("index found");
        id = result.data.rows[0].id;
        return gadget.state.db.get(result.data.rows[0].id)
          .push(function(result){
            console.log("started index import");
            var tmp_index = FlexSearch.create("memory");
            tmp_index.import(result.index, gadget.state.msgpack);
            console.log("index import done");
            gadget.changeState({
              index : tmp_index
            });
          })
          .push(function(){
            return gadget.changeState({
              index_id : id
            });
          });
      }
    });
  })
    
  .declareMethod("is_empty", function(){
    return this.state.db.allDocs()
      .push(function(all_docs){
        return all_docs.data.total_rows === 0;
      });
  })
  
  .declareMethod("get_index", function(){
    console.log(this.state.index.info());
    console.log(this.state.msgpack);
    return this.state.index.export(this.state.msgpack);
    //return this.state.index.export({serialize: false});
  })
  
  .declareMethod("add_index", function(serialized_index){
    console.log("adding index");
    this.state.index.import(serialized_index, this.state.msgpack);
    //this.state.index.import(serialized_index, {serialize: false});
    console.log(this.state.index.info());
  });
 
}(window, document, RSVP, rJS, jIO));